//+------------------------------------------------------------------+
//|                                                   SVM_EA_inc.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2005

//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);

// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import

//+------------------------------------------------------------------+
//| EX4 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex4"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#import "Project3.dll"
int Train(
            double t[],//iTime(NULL,TrainTimeFrame,i);
            double c[],//iClose(NULL,TrainTimeFrame,i);
            double l[],//iLow(NULL,TrainTimeFrame,i);
            double h[],//iHigh(NULL,TrainTimeFrame,i);
				int	NrTrainBars,
				int	FutureWindow,
				int	StopLoss,
				int	TakeProfit,
				double Point1,
				double &train_result[],//output											
		      double &train_time[]//output
            );
int SvmCreateDyn_3tf_1(
                     double t[],//iTime(NULL,TrainTimeFrame,i);
                     double c[],//iClose(NULL,TrainTimeFrame,i);
                     double l[],//iLow(NULL,TrainTimeFrame,i);
                     double h[],//iHigh(NULL,TrainTimeFrame,i);
                     double ma5_M5[],//iMA(NULL,PERIOD_M5,5,0,MODE_SMA,PRICE_CLOSE,i);
                     double ma10_M5[],//iMA(NULL,PERIOD_M5,10,0,MODE_SMA,PRICE_CLOSE,i);
                     double ma15_M5[],//iMA(NULL,PERIOD_M5,15,0,MODE_SMA,PRICE_CLOSE,i); 
                     double ma5_H1[],
                     double ma10_H1[],
                     double ma15_H1[],
                     double ma5_H4[],
                     double ma10_H4[],
                     double ma15_H4[],
							int NrTrainBars,
							int NrAttrib,
							int FutureWindow,
							int StopLoss,
							int TakeProfit,
							double Point1,
							string file_name1//="c:\\trade_model_dyn_3tf_1_.txt";
							);
int SvmPredictDyn_3tf_1(
                     double ma5_M5[],//iMA(NULL,PERIOD_M5,5,0,MODE_SMA,PRICE_CLOSE,i);
                     double ma10_M5[],//iMA(NULL,PERIOD_M5,10,0,MODE_SMA,PRICE_CLOSE,i);
                     double ma15_M5[],//iMA(NULL,PERIOD_M5,15,0,MODE_SMA,PRICE_CLOSE,i); 
                     double _ma5_H1[],
                     double _ma10_H1[],
                     double _ma15_H1[],
                     double _ma5_H4[],
                     double _ma10_H4[],
                     double _ma15_H4[],
							int NrTestBars,	//
					      int NrAttrib,		//
							double Point1,										 
							string model_file_name_1, 										
							double &ptr_predict_label__1[]//output label                     
							);	
int SvmCreateDyn_3tf_1_In(
                     double t[],//iTime(NULL,TrainTimeFrame,i);
                     double c[],//iClose(NULL,TrainTimeFrame,i);
                     double l[],//iLow(NULL,TrainTimeFrame,i);
                     double h[],//iHigh(NULL,TrainTimeFrame,i);
                     double ma5_M5[],//iMA(NULL,PERIOD_M5,5,0,MODE_SMA,PRICE_CLOSE,i);
                     double ma10_M5[],//iMA(NULL,PERIOD_M5,10,0,MODE_SMA,PRICE_CLOSE,i);
                     double ma15_M5[],//iMA(NULL,PERIOD_M5,15,0,MODE_SMA,PRICE_CLOSE,i); 
                     double ma5_H1[],
                     double ma10_H1[],
                     double ma15_H1[],
                     double ma5_H4[],
                     double ma10_H4[],
                     double ma15_H4[],
							int NrTrainBars,
							int NrAttrib,
							int FutureWindow,
							int StopLoss,
							int TakeProfit,
							double Point1,
							string file_name1,//="c:\\trade_model_dyn_3tf_1_.txt";
							int fl=0, //==0 normalize
							int ftype=0, //==0 file type  = libsvm , ==1 csv without header, ==2 = csv for Neuro Solution
							int create=0 //create==0 don't create model							
							);
int SvmPredictDyn_3tf_1_Out(
                     double _ma5_M5[],//iMA(NULL,PERIOD_M5,5,0,MODE_SMA,PRICE_CLOSE,i);
                     double _ma10_M5[],//iMA(NULL,PERIOD_M5,10,0,MODE_SMA,PRICE_CLOSE,i);
                     double _ma15_M5[],//iMA(NULL,PERIOD_M5,15,0,MODE_SMA,PRICE_CLOSE,i); 
                     double _ma5_H1[],
                     double _ma10_H1[],
                     double _ma15_H1[],
                     double _ma5_H4[],
                     double _ma10_H4[],
                     double _ma15_H4[],
							int NrTestBars,	//
					      int NrAttrib,		//
							double Point1,										 
							string model_file_name_1, 										
							double &ptr_predict_label__1[],//output label                     
							int fl=0  //fl==0 create prediction output
							);																																					
#import